package com.osoboo.jira.metadata;

import java.util.UUID;

import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;

import com.atlassian.jira.functest.framework.FuncTestCase;
import com.atlassian.jira.functest.framework.locator.WebPageLocator;

@Ignore
public class MyPluginTest extends FuncTestCase {

	@Before
	public void setUpTest() {
	//	administration.restoreData("base_with_project_2011_05_03.xml");
	}
	
	public void testfu() {
		
	}

	/**
	 * error messages.
	 */
	@Test
	@Ignore
	public void usersPermissions() {
		navigation.logout();
		navigation.gotoPage("/browse/SP#selectedTab=com.osoboo.jira-metadata-plugin%3AJIRA-Metadata-project-tab");
		text.assertTextPresent(new WebPageLocator(tester), "You cannot view this page as a guest.");

		navigation.login("admin", "admin");

		navigation.gotoPage("/browse/SP");
		tester.clickLink("JIRA-Metadata-project-tab-panel");
		text.assertTextPresent(new WebPageLocator(tester), "JIRA Metadata");
		text.assertTextPresent(new WebPageLocator(tester), "You can create a new metadata or manage an existing one.");
		text.assertTextPresent(new WebPageLocator(tester), "Edit Metadata");

		navigation.logout();
		navigation.login("test", "test");
		navigation.gotoPage("/browse/SP");
		tester.clickLink("JIRA-Metadata-project-tab-panel");
		text.assertTextNotPresent(new WebPageLocator(tester), "You can create a new metadata or manage an existing one.");
		text.assertTextNotPresent(new WebPageLocator(tester), "Edit Metadata");
		text.assertTextPresent(new WebPageLocator(tester), "All project metadata.");
	}
	
	@Test
	@Ignore
	public void createEditDeleteMetadata() {
		// create metadata
		navigation.gotoPage("/browse/SP");
		tester.clickLink("JIRA-Metadata-project-tab-panel");
		tester.setFormElement("metadataKey", "create-edit-delete");
		tester.setFormElement("metadataValue", "some value");
		tester.clickButton("save_metadata");
		text.assertTextPresent("create-edit-delete");
		text.assertTextPresent("some value");

		// edit metadata
		tester.setFormElement("metadataKey", "create-edit-delete");
		tester.setFormElement("metadataValue", "some other value");
		tester.clickButton("save_metadata");
		text.assertTextPresent("create-edit-delete");
		text.assertTextNotPresent("some value");
		text.assertTextPresent("some other value");
		
		// delete metadata
		tester.clickLink("delete-create-edit-delete");
		text.assertTextNotPresent("create-edit-delete");
		text.assertTextNotPresent("some value");
		text.assertTextNotPresent("some other value");
	}

	@Test
	@Ignore
	public void createViewCustomField() {
		String randomKey = new StringBuilder("PK-23-Sys-3").append(UUID.randomUUID().toString()).toString();
		// pre-check
		navigation.issue().viewIssue("SP-1");
		text.assertTextPresent(new WebPageLocator(tester), "Sample Feature");
		text.assertTextNotPresent("Account Info");

		// custom field add
		navigation.gotoAdminSection("view_custom_fields");
		tester.clickLink("add_custom_fields");
		tester.checkCheckbox("fieldType", "com.osoboo.jira-metadata-plugin:JIRA-Metadata-view-project-metadata-field");
		tester.clickButton("nextButton");
		tester.setFormElement("fieldName", "Account Info");
		tester.clickButton("nextButton");
		tester.checkCheckbox("associatedScreens", "1");
		tester.clickButton("update_submit");
		// configure custom field
		tester.clickLink("config_customfield_10000");
		tester.clickLink("customfield_10000-edit-default-value");
		tester.setFormElement("customfield_10000", "accounting.code");
		tester.clickButton("set_defaults_submit");
		// admin screen tests
		text.assertTextPresent("Default Configuration Scheme for Account Info");
		text.assertTextPresent("Default Value");
		text.assertTextPresent("accounting.code");
		// issue tests
		navigation.issue().viewIssue("SP-1");
		text.assertTextPresent("Sample Feature");
		text.assertTextPresent("Account Info");
		text.assertTextNotPresent("accounting.code");
		text.assertTextNotPresent(randomKey);
		// create metadata
		navigation.gotoPage("/browse/SP");
		tester.clickLink("JIRA-Metadata-project-tab-panel");
		tester.setFormElement("metadataKey", "accounting.code");
		tester.setFormElement("metadataValue", randomKey);
		tester.clickButton("save_metadata");
		text.assertTextPresent("accounting.code");
		text.assertTextPresent(randomKey);
		// im Issue
		navigation.issue().viewIssue("SP-1");
		text.assertTextPresent("Sample Feature");
		text.assertTextPresent("Account Info");
		text.assertTextNotPresent("accounting.code");
		text.assertTextPresent(randomKey);
	}
	
	@Test
	@Ignore
	public void createCalcCustomField() {
		// pre-check
		navigation.issue().viewIssue("SP-1");
		text.assertTextPresent(new WebPageLocator(tester), "Sample Feature");
		text.assertTextNotPresent("Amount");

		// custom field add
		navigation.gotoAdminSection("view_custom_fields");
		tester.clickLink("add_custom_fields");
		tester.checkCheckbox("fieldType", "com.osoboo.jira-metadata-plugin:JIRA-Metadata-calc-field");
		tester.clickButton("nextButton");
		tester.setFormElement("fieldName", "Amount");
		tester.clickButton("nextButton");
		tester.checkCheckbox("associatedScreens", "1");
		tester.clickButton("update_submit");
		// configure custom field
		tester.clickLink("config_customfield_10000");
		tester.clickLink("customfield_10000-edit-default-value");
		tester.setFormElement("customfield_10000", "#set( $accRate = $metadataService.getMetadataValue($issue.projectObject, 'accounting.hour.rate') ) #set( $issueTime = $math.div($issue.timeSpent, 3600) ) #set( $amount = $math.mul($accRate, $issueTime) ) $!amount");
		tester.clickButton("set_defaults_submit");
		// admin screen tests
		text.assertTextPresent("Default Configuration Scheme for Amount");
		text.assertTextPresent("Default Value");
		text.assertTextPresent("accounting.hour.rate");
		// create metadata
		navigation.gotoPage("/browse/SP");
		tester.clickLink("JIRA-Metadata-project-tab-panel");
		tester.setFormElement("metadataKey", "accounting.hour.rate");
		tester.setFormElement("metadataValue", "12.5");
		tester.clickButton("save_metadata");
		text.assertTextPresent("accounting.hour.rate");
		text.assertTextPresent("12.5");
		// Issue
		navigation.issue().viewIssue("SP-1");
		text.assertTextPresent("Sample Feature");
		text.assertTextPresent("Amount");
		text.assertTextNotPresent("accounting.hour.rate");
		text.assertTextPresent("31.25");
		
	}

}
